dk.plugin "transport", ["websockets"], ->
  mod = {}
  counter = 0
  callbacks = {}
  socketListener = null

  # PUBLIC METHODS
  mod.send = (key, data, cb) ->
    if this.useWebsockets
      ensureSocketListener()

      messageId = "message-#{counter}"
      counter += 1
      callbacks[messageId] = cb
      dk.websockets.send id: messageId, key: key, data: data
    else
      data = data: JSON.stringify(data)
      $.post "/dk/transport/#{key}", data, cb

  # PRIVATE METHODS
  ensureSocketListener = ->
    unless socketListener
      socketListener = (msg) ->
        messageId = msg.id
        data = msg.data
        cb = callbacks[messageId]
        cb(data)
        delete cb
      dk.websockets.on "message", socketListener
    
  return mod
